package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbInviterBo;
import com.yongqi.xinrenli.domain.vo.DbInviterVo;
import com.yongqi.xinrenli.domain.DbInviter;
import com.yongqi.xinrenli.mapper.DbInviterMapper;
import com.yongqi.xinrenli.service.IDbInviterService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 邀请Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbInviterServiceImpl implements IDbInviterService {

    private final DbInviterMapper baseMapper;

    /**
     * 查询邀请
     */
    @Override
    public DbInviterVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询邀请列表
     */
    @Override
    public TableDataInfo<DbInviterVo> queryPageList(DbInviterBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbInviter> lqw = buildQueryWrapper(bo);
        Page<DbInviterVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询邀请列表
     */
    @Override
    public List<DbInviterVo> queryList(DbInviterBo bo) {
        LambdaQueryWrapper<DbInviter> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbInviter> buildQueryWrapper(DbInviterBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbInviter> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getInviterId() != null, DbInviter::getInviterId, bo.getInviterId());
        lqw.like(StringUtils.isNotBlank(bo.getInviterName()), DbInviter::getInviterName, bo.getInviterName());
        lqw.eq(bo.getInviteeId() != null, DbInviter::getInviteeId, bo.getInviteeId());
        lqw.like(StringUtils.isNotBlank(bo.getInviteeName()), DbInviter::getInviteeName, bo.getInviteeName());
        lqw.eq(bo.getStatus() != null, DbInviter::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增邀请
     */
    @Override
    public Boolean insertByBo(DbInviterBo bo) {
        DbInviter add = BeanUtil.toBean(bo, DbInviter.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改邀请
     */
    @Override
    public Boolean updateByBo(DbInviterBo bo) {
        DbInviter update = BeanUtil.toBean(bo, DbInviter.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbInviter entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除邀请
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
